<?php
// 号码隐私保护类
class SMS
{
    // 网站的appkey
    private $appkey = "";
    // appkey 对应的秘钥
    private $secret = "";
    public $apiurl  = "https://api-sms.mixcom.cn";

    /**
     * 设置appkey
     * @param appkey
     */
    public function setAppkey($appkey)
    {
        $this->appkey = $appkey;
    }

    /**
     * 设置秘钥
     * @param secret
     */
    public function setSecret($secret)
    {
        $this->secret = $secret;
    }

    public function send($params = array())
    {
        $url    = $this->apiurl . "/sms/sendsms";
        $json   = $this->post($url, $params);
        return $json;
    }

    private function post($url, $params = array())
    {
        $params['time']   = time();
        $params['appkey'] = $this->appkey;
        $params['sign']   = $this->getSign($params);

        $ch = curl_init(); //初始化curl
        curl_setopt($ch, CURLOPT_URL, $url); //抓取指定网页
        curl_setopt($ch, CURLOPT_HEADER, 0); //设置header
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1); //要求结果为字符串且输出到屏幕上
        curl_setopt($ch, CURLOPT_POST, 1); //post提交方式
        curl_setopt($ch, CURLOPT_POSTFIELDS, $params);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
        curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, false);
        $data = curl_exec($ch); //运行curl
        curl_close($ch);
        return $data;
    }

    private function getSign($params)
    {
        // key转换为小写
        $params = array_change_key_case($params, CASE_LOWER);
        // 排除不需要加密的参数
        foreach ($params as $key => $val) {
            if ($key == 'c' || $key == 'a' || $key == 'sign') {
                // 从数组中移除
                unset($params[$key]);
            }
            if ($val === '') {
                // 空值从数组中移除
                unset($params[$key]);
            }
        }
        // 对key进行排序, 按名称升序
        ksort($params);
        // 将数据连接，进行加密
        $data = '';
        foreach ($params as $key => $val) {
            $data .= $val;
        }
        $data .= $this->secret;
        $sign = strtolower(sha1($data . sha1($this->secret)));
        return $sign;
    }
}
